%define enable_java		0
%define _requires_exceptions	libCg\\|libGL\\|libjack\\|libjawt\\|libXxf86vm

Name:		polymake
Summary:	Algorithms around polytopes and polyhedra
Version:	2.9.9
Release:	%mkrel 3
License:	GPL
Group:		Sciences/Mathematics
URL:		http://www.polymake.de/

%define topname %{name}-%{version}
Source:		ftp://ftp.math.tu-berlin.de/pub/combi/polymake-alpha/%{topname}.tar.bz2
Source1:	as3.gif

Provides:	perl(JavaView)
Provides:	perl(Polymake::Core::InteractiveCommands)
Provides:	perl(Polymake::Core::RuleFilter)
Provides:	perl(Polymake::Background)
Provides:	perl(Polymake::Namespaces)
Provides:	perl(Polymake::regex.pl)
Provides:	perl(Polymake::utils.pl)
Provides:	perl(Polymake::Sockets)

Requires:	make
Requires:	perl-devel
Requires:	perl >= 5.8.1 gcc-c++
Requires:	perl-XML-LibXML
Requires:	perl-XML-Writer
Requires:	perl-Term-ReadLine-Gnu
Requires:	singular
BuildRequires:	gmp-devel
BuildRequires:	perl-devel gcc-c++ libgmpxx-devel
BuildRequires:	perl-XML-Writer
BuildRequires:	perl-XML-LibXSLT

%if %{enable_java}
# libcg is in non free
Requires:	libcg
Requires:       java > 1.5
Requires:       jogl
BuildRequires:  java-rpmbuild
BuildRequires:	ant
%endif

BuildRequires:	xsltproc

Patch0:		int_max.patch
Patch1:		polymake-2.9.9-format.patch
Patch2:		polymake-2.9.9-make-3.82.patch
Patch3:		polymake-2.9.9-without-java.patch

BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
Polymake is a versatile tool for the algorithmic treatment of
polytopes and polyhedra.  It offers a unified interface to a wide
variety of algorithms and free software packages from the computational
geometry field, such as convex hull computation or visualization tools.

The 2.9 series are test versions towards the "next generation" polymake.
They introduce an interactive shell, the XML-base file format, more
efficient C++/perl interface, and many other new features.

%files
%defattr(-,root,root,-)
%{_bindir}/polymake
%{_datadir}/polymake
%dir %{_libdir}/polymake
%dir %{_libdir}/polymake/perlx
%{_libdir}/polymake/lib
%config %{_libdir}/polymake/conf.make
%doc %{_docdir}/%{name}

%post
echo "Building perl extensions for polymake..."
[ -d $TMPDIR ] || TMPDIR=$HOME/tmp
[ -d $TMPDIR ] || exit 1
rm -rf $TMPDIR/%{name}-perlx
mkdir $TMPDIR/%{name}-perlx
pushd $TMPDIR/%{name}-perlx || exit 1
    export TOP=%{_datadir}/polymake
    /usr/bin/perl %{_datadir}/polymake/perl/ext/Makefile.PL
    make all pure_install InstallDir=%{_libdir}/polymake
popd
rm -rf $TMPDIR/%{name}-perlx

%triggerin -- perl
eval perl_`/usr/bin/perl -V:version`
if [ ! -d %{_libdir}/polymake/perlx/${perl_version} ]; then
    echo "Building perl extensions for polymake..."
    [ -d $TMPDIR ] || TMPDIR=$HOME/tmp
    [ -d $TMPDIR ] || exit 1
    rm -rf $TMPDIR/%{name}-perlx
    mkdir $TMPDIR/%{name}-perlx
    pushd $TMPDIR/%{name}-perlx || exit 1
	export TOP=%{_datadir}/polymake
	/usr/bin/perl %{_datadir}/polymake/perl/ext/Makefile.PL
	make all pure_install InstallDir=%{_libdir}/polymake
    popd
    rm -rf $TMPDIR/%{name}-perlx
fi

%preun
if [ $1 = 0 ]; then
   rm -rf %{_libdir}/polymake/perlx/*
fi

%prep
%setup -q -n %{topname}

%define ProjectTop %{_builddir}/%{topname}

%patch0	-p1
%patch1	-p1
%patch2	-p1

%if !%{enable_java}
%patch3 -p1
# do not cause it to link to or require 64 bit libraries
%endif

%build

if [ "%{_host_cpu}" = x86_64 -a "%{_target_cpu}" != x86_64 ]; then
  LDflags="LDFLAGS=-m32"
fi

./configure				\
	--prefix=%{_prefix} 		\
	--libdir=%{_libdir}/polymake	\
	--docdir=%{_docdir}/%{name}	\
        --build=%{_target_cpu}		\
%if !%{enable_java}
	--without-javaview		\
	--without-java			\
%endif
	CFLAGS="$(perl -e '$_=q{'"$RPM_OPT_FLAGS"'}; s/(?:^|\s)-(?:g|O\d)(?=\s|$)//g; print;')" $LDFLAGS
make Arch=%{_target_cpu} %{?_smp_mflags}%{?!_smp_mflags:%(NCPUS=`grep -c '^processor' /proc/cpuinfo`; [ -n "$NCPUS" -a "$NCPUS" -gt 1 ] && echo -j$NCPUS )} ProcessDep=n

%install
make Arch=%{_target_cpu} PREFIX=%{_prefix} DESTDIR=%{buildroot} install docs
perl support/install.pl -m 755 perl/ext %{buildroot}%{_datadir}/%{name}/perl/ext
mkdir -p %{buildroot}%{_libdir}/polymake/perlx
cp -fa %{SOURCE1} %{buildroot}%{_datadir}/%{name}

# give write permissions to owner so that strip works
find %{buildroot}%{_libdir} | xargs chmod u+w

find %{buildroot}%{_libdir} -name \*.so | xargs chmod a-x

%if %{enable_java}
    %ifarch x86_64 ppc64
	rm -fr %{buildroot}%{_libdir}/%{name}/jreality/jni/linux32
    %else
	rm -fr %{buildroot}%{_libdir}/%{name}/jreality/jni/linux64
    %endif
%else
    rm -fr %{buildroot}%{_libdir}/%{name}/lib/jreality
%endif


%changelog
* Thu Nov 18 2010 Paulo Andrade <pcpa@mandriva.com.br> 2.9.9-3mdv2011.0
+ Revision: 598818
- Rewrite rpm scriptlets to better match Mandriva
- Add build option to disable java and make it default

* Wed Nov 17 2010 Paulo Andrade <pcpa@mandriva.com.br> 2.9.9-1mdv2011.0
+ Revision: 598172
- Update to polymake 2.9.9

  + Shlomi Fish <shlomif@mandriva.org>
    - Correct a typo in the %%description

* Thu Feb 11 2010 Paulo Andrade <pcpa@mandriva.com.br> 2.9.7-2mdv2010.1
+ Revision: 504337
- Correct recursive dependency

* Wed Feb 10 2010 Funda Wang <fwang@mandriva.org> 2.9.7-1mdv2010.1
+ Revision: 503627
- fix str fmt
- New version 2.9.7

* Mon May 18 2009 Paulo Andrade <pcpa@mandriva.com.br> 2.9.6-6mdv2010.0
+ Revision: 377396
+ rebuild (emptylog)

* Fri May 08 2009 Paulo Andrade <pcpa@mandriva.com.br> 2.9.6-5mdv2010.0
+ Revision: 373557
+ rebuild (emptylog)

* Tue Apr 28 2009 Paulo Andrade <pcpa@mandriva.com.br> 2.9.6-4mdv2009.1
+ Revision: 369091
- Correct -Wformat-security=error and build of perl modules.

* Mon Mar 09 2009 Paulo Andrade <pcpa@mandriva.com.br> 2.9.6-3mdv2009.1
+ Revision: 353302
- Ensure the package is functional (and can be installed), by adding proper
  requires, and manually providing some perl(Polymake::...) not found by the
  __find_provides script.

* Sat Mar 07 2009 Paulo Andrade <pcpa@mandriva.com.br> 2.9.6-2mdv2009.1
+ Revision: 350720
- Update for build in Mandriva.
  o Add proper BuildRequires.
  o Correct a build problem with g++ 4.3.2.
  o Disable java interface build by default.
- Initial import of polymake.
  This initial import matches, without modifications, the srpm available at
  http://www.math.tu-berlin.de/polymake/download-alpha/polymake-2.9.6-1.src.rpm
- polymake

